#include "cmp_demo.h"
#include "isr.h"
volatile uint32_t g_Cmp0IntTaken;
void Cmp0_Init()
{
	GPIO_InitTypeDef GPIO_InitStruct ={0};
	CMP_InitTypeDef CMP_InitStruct = {0};
	ISR_InitTypeDef_t ISR_InitStructure ;


	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_2;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_ANA;
	GPIO_Init(GPIO_PORT2,&GPIO_InitStruct);       //P22 VCIN0 pin
	
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_7;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_ANA;
	GPIO_Init(GPIO_PORT14,&GPIO_InitStruct);     //P147 VREF0

    GPIO_PinAFConfig(GPIO_PORT12, GPIO_Pin_0, GPIO_P120, GROUP_AF_TXD2);
	
	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_OType  = GPIO_OType_PP;	
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_DIG;
	GPIO_Init(GPIO_PORT12,&GPIO_InitStruct);     //P147 VREF0

	CMP_InitStruct.CMP_Channel = CMP_Channel_0;  //Ƚ0
	CMP_InitStruct.CMP_PositiveSide = CMP0_PositiveSide_VCIN0;//ѡȽź
	CMP_InitStruct.CMP_NegativeSide = CMP0_NegativeSide_IVREF;//ڲ׼ѹ
	CMP_InitStruct.CMP_NegVref = CMP_Vref_VDD_VSS;//ѡvdd vss Ϊڲpower/ground οѹ
	CMP_InitStruct.CMP_NegVrefVol = 128; //Ƚû׼ѹ趨 (VDDAVref/256)*128	
	CMP_InitStruct.CMP_Int = CMP_Int_Enable;       //Ƚжʹ
	CMP_InitStruct.CMP_IntReq = CMP_IntReq_Rising; //Ƚشж
	CMP_InitStruct.CMP_Filter = CMP_Filter_None;  //Ƚ˲
	CMP_InitStruct.CMP_Out2port = CMP_Out_Enable;//ֹcmp0ȽVCOUT0

    ISR_Register(CMP0_IRQn, cmp0_interrupt);     //жϷ·ע

	CMP_Init(&CMP_InitStruct);
}

void cmp0_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(CMP0_IRQn);     /* clear INTCMP1 interrupt flag */
	g_Cmp0IntTaken++;
}

void Cmp1_Init()
{
	GPIO_InitTypeDef GPIO_InitStruct ={0};
	CMP_InitTypeDef CMP_InitStruct = {0};
	ISR_InitTypeDef_t ISR_InitStructure ;


	GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_0;
	GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_ANA;
	GPIO_Init(GPIO_PORT0,&GPIO_InitStruct);       //P00 VCIN10 pin

	CMP_InitStruct.CMP_Channel = CMP_Channel_1;  //Ƚ1
	CMP_InitStruct.CMP_PositiveSide = CMP1_PositiveSide_VCIN10;//ѡȽź
	CMP_InitStruct.CMP_NegativeSide = CMP1_NegativeSide_IVREF;//ڲ׼ѹ
	CMP_InitStruct.CMP_NegVref = CMP_Vref_VDD_VSS;//ѡvdd vss Ϊڲpower/ground οѹ
	CMP_InitStruct.CMP_NegVrefVol = 128; //Ƚû׼ѹ趨 (VDDAVref/256)*128
	CMP_InitStruct.CMP_Int = CMP_Int_Enable;//Ƚжʹ
	CMP_InitStruct.CMP_IntReq = CMP_IntReq_Rising; //Ƚشж
	CMP_InitStruct.CMP_Filter = CMP_Filter_None;//Ƚ˲

	CMP_Init(&CMP_InitStruct);
    ISR_Register(CMP1_IRQn, cmp1_interrupt);     //жϷ·ע

}
void cmp1_interrupt(void *msg)
{
    INTC_ClearPendingIRQ(CMP1_IRQn);     /* clear INTCMP1 interrupt flag */
}
