/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G139
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "tim_demo.h"
#include "elc.h"
#define TIM_ENABLE   1

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/


int main()
{
    uint32_t msCnt;     // count value of 1ms

    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);



#if TIM_ENABLE
    extern uint32_t g_Int_Taken;
    Tim40_DelayCounter();
    ELC_Start(_05_ELC_EVENT_INTTM00, _03_ELC_EVENT_LINK_TI01);
    Tim40_SquareOutput();

    /*Example2:Tim4 operates output different duty pwm*/
#endif

}



