#ifndef __SPIHS_DEMO_H__
#define __SPIHS_DEMO_H__
#include "spi.h"
#include "gpio.h"
#include "isr.h"
#define SPI_GROUP1  (uint8_t)0x01
#define SPI_GROUP2  (uint8_t)0x02
#define SPI_GROUP3  (uint8_t)0x03


extern uint8_t g_spi_tx_end, g_spi_rx_end;

void spi0hs_interrupt(void *msg);
void spi1hs_interrupt(void *msg);
void Spihs_Init(void);

void Spihs_Int_Write(uint8_t *tx_buf, uint16_t tx_num);
void Spihs_Int_Read(uint8_t *rx_buf, uint16_t rx_num);
void Spihs_Dma_Write(uint8_t *tx_buf, uint16_t tx_num);
void Spihs_Dma_Read(uint8_t *rx_buf, uint16_t rx_num);
void Spihs_Int_TxRx(uint8_t *tx_buf, uint16_t tx_num, uint8_t *rx_buf, uint16_t rx_num);

void Spihs_Dma_TxRx(uint8_t *tx_buf, uint16_t tx_num, uint8_t *rx_buf, uint16_t rx_num);

#endif
